<?php

class ControlBoard extends DataObject {

	static $db = array(
		"Code" => "Varchar(20)",
		"Name" => "Varchar(200)"
	);

	static $has_many = array(
		"ControlSub" => "ControlSubBoard"
	);

	static $indexes = array(
		"Code" => true
	);

	public static $summary_fields = array(
		"Code" => "Code",
		"Name" => "Name"
	);

//        public static $casting = array(
//		"IsPublished" => "Boolean",
//		"AllowPublished" => "Varchar"
//	);

	public static $searchable_fields = array(
		'Code' => "PartialMatchFilter",
		'Name' => "PartialMatchFilter"
//                ,
//		'DoNotAllowSales' => array(
//			'field' => 'CheckboxField',
//			'filter' => 'MarkerBoardFilters_AllowSales',
//			'title' => 'Allow Sales'
//		)
	);

	//static $default_sort = "\"DoNotAllowSales\" ASC, \"Name\" ASC";
        static $default_sort = "\"Name\" ASC";

	public static $singular_name = "Control";
		function i18n_singular_name() { return _t("ControlBoard.CONTROL", "Control");}

	public static $plural_name = "Controls";
		function i18n_plural_name() { return _t("ControlBoard.CONTROLS", "Controls");}

	public static $description = "A Control.";

	public function canCreate($member = null) {
		return $this->canEdit($member);
	}

	public function canView($member = null) {
		return true;
	}

	public function canEdit($member = null) {
		if(!$member) {
			$member = Member::currentUser();
		}
                
		return parent::canEdit($member);
	}

	function canDelete($member = null){
		return true;
	}

        public static function get_Control_id($controlCode = "") {
//		if(!$markerCode) {
//			$markerCode = self::get_marker();
//		}
		$control = ControlBoard::get()
			->filter(array("Code" => $controlCode))
			->first();
		if($control) {
			return $control->ID;
		}
		return 0;
	}
}

