<?php

class ControlSubBoard extends DataObject {

	static $db = array(
		"Code" => "Varchar(20)",
		"Name" => "Varchar(200)"
	);

	static $has_one = array(
		"Control" => "ControlBoard"
	);

	static $indexes = array(
		"Code" => true
	);

	static $default_sort = "\"Name\" ASC";

	public static $singular_name = "ControlSub";
		function i18n_singular_name() { return _t("ControlSubBoard.MARKERSUB", "Control Sub");}

	public static $plural_name = "ControlSubs";
		function i18n_plural_name() { return _t("ControlSubBoard.CONTROLSUBS", "Control Subs");}

	public static $searchable_fields = array(
		"Name" => "PartialMatchFilter",
		"Code" => "PartialMatchFilter"
	);

	public static $field_labels = array(
		"Name" => "Name"
	);

	public static $summary_fields = array(
		"Name" => "Name",
		"Control.Title"
	);

	public static $description = "A Control within a Sub Controls.";

	public static function show() {
		return ControlSubBoard::get()->First() ? true : false;
	}

	function getCMSFields() {
		$fields = parent::getCMSFields();
//                $gridFieldConfig = GridFieldConfig_RelationEditor::create()->addComponents(
//			new GridFieldDeleteAction('unlinkrelation')
//		);
//	
//                $gridFieldConfig->getComponentByType('GridFieldDataColumns')->setDisplayFields(array(
//                    'Marker.Title'=> 'Marker',
//                    'Code' => 'Code',
//                    'Name' => 'Name'                  
//                )); 
//                
//		$gridfield = new GridField("Marker", "MarkerBoard", $this->MarkerSubBoard(), $gridFieldConfig);
//		$fields->addFieldToTab('Root.Markers', $gridfield);
		return $fields;
	}

        public function validate() {
            $valid = parent::validate();
            if($this->Code == '') {
                $this->Code = 'Please Enter Code';
                $valid->error(_t('',
                     '"{field}" is required',
                     array('field' => 'Code')
                ));
            }
            
            if($this->ControlID == '') {
                $this->ControlID = 'Please Select Control';
                $valid->error(_t('',
                     '"{field}" is required',
                     array('field' => 'ControlID')
                ));
            }
            
//            foreach(self::$required_fields as $field) {
//                if (empty($this->$field)) {
//                        $valid->error(_t('',
//                                '"{field}" is required',
//                                        array('field' => isset(self::$field_labels[$field])?self::$field_labels[$field]:$field)
//                        ));
//                }
//            }
                
            return $valid;
    }
}

