<?php

class MarkerBoard extends DataObject {

	static $db = array(
		"Code" => "Varchar(20)",
		"Name" => "Varchar(200)"
	);

	static $has_many = array(
		"MarkerSub" => "MarkerSubBoard"
	);

	static $indexes = array(
		"Code" => true
	);

	public static $summary_fields = array(
		"Code" => "Code",
		"Name" => "Name"
	);

//        public static $casting = array(
//		"IsPublished" => "Boolean",
//		"AllowPublished" => "Varchar"
//	);

	public static $searchable_fields = array(
		'Code' => "PartialMatchFilter",
		'Name' => "PartialMatchFilter"
	);

	//static $default_sort = "\"DoNotAllowSales\" ASC, \"Name\" ASC";
        static $default_sort = "\"Name\" ASC";

	public static $singular_name = "Marker";
		function i18n_singular_name() { return _t("MarkerBoard.MARKER", "Marker");}

	public static $plural_name = "Markers";
		function i18n_plural_name() { return _t("MarkerBoard.MARKERS", "Markers");}

	public static $description = "A marker.";

	public function canCreate($member = null) {
		return $this->canEdit($member);
	}

	public function canView($member = null) {
		return true;
	}

	public function canEdit($member = null) {
		if(!$member) {
			$member = Member::currentUser();
		}
                
		return parent::canEdit($member);
	}

	function canDelete($member = null){
		return true;
	}

        public static function get_marker_id($markerCode = "") {
//		if(!$markerCode) {
//			$markerCode = self::get_marker();
//		}
		$marker = MarkerBoard::get()
			->filter(array("Code" => $markerCode))
			->first();
		if($marker) {
			return $marker->ID;
		}
		return 0;
	}
        
        public function validate() {
            $valid = parent::validate();
            if($this->Code == '') {
                $this->Code = 'Please Enter Code';
                $valid->error(_t('',
                     '"{field}" is required',
                     array('field' => 'Code')
                ));
            }
            
            if($this->Name == '') {
                $this->Name = 'Please Enter Name';
                $valid->error(_t('',
                     '"{field}" is required',
                     array('field' => 'Name')
                ));
            }
                
            return $valid;
        }
    
        public function onBeforeDelete(){
            parent::onBeforeDelete();
            if($this->getMarkerSubCount($this->ID) > 0){
                    //How to stop deletion process and reditrct to main page and display error message?
            }
	}
        
        function getMarkerSubCount($val){
          $sqlQuery = new SQLQuery();
          $sqlQuery->setFrom('markersubboard', 'markerboard');
          $sqlQuery->selectField('count(markersubboard.ID) AS CountMarkerSub');
          $sqlQuery->addWhere('markersubboard.MarkerID = '.$val);
          
          return $sqlQuery->execute()->value();
        }
}

